! MMS file for building GOPHERD.EXE

! If MMS/MACRO="PRODUCTION=OK" or just MMS for debugging
.IFDEF  PRODUCTION
GOPHERD_DEBUG = /nodebug
GOPHERD_EXE  = gopherd.exe
GOPHERD_PRODUCTION = gopher$root:[v1216]gopherd.exe
BUILD_INDEX_EXE = build_index.exe
BUILD_INDEX_PRODUCTION = gopher$root:[v1216]build_index.exe
QUERY_EXE = query.exe
QUERY_PRODUCTION = gopher$root:[v1216]query.exe
LOOKASIDE_EXE = lookaside.exe
LOOKASIDE_PRODUCTION = gopher$root:[v1216]lookaside.exe
.ELSE
GOPHERD_DEBUG = /debug
GOPHERD_EXE  = gopher_debug.exe
BUILD_INDEX_EXE = build_index_debug.exe
QUERY_EXE = query_debug.exe
LOOKASIDE_EXE = lookaside_debug.exe
.ENDIF


! The GopherD object file list
GOPHERD_OBJECT =-
 gopherd.obj,-
 gopherdconf.obj,-
 index.obj,-
 waisgopher.obj,-
 ftp.obj,-
 debug.obj,-
 sockets.obj,-
 kernutils.obj,-
 special.obj,-
 gdgopherdir.obj,-
 gsgopherobj.obj,-
 compatible.obj,-
 daarray.obj,-
 strstring.obj,-
 site.obj,-
 ext.obj,-
 globals.obj,-
 util.obj

! The query object file list
QUERY_OBJECT =-
 query.obj

! The build_index object file list
BUILD_INDEX_OBJECT =-
 build_index.obj,-
 indexcld.obj

! The lookaside object file list
LOOKASIDE_OBJECT =-
 lookaside.obj,-
 compatible.obj

.IFDEF PRODUCTION
gopher : $(GOPHERD_PRODUCTION) $(BUILD_INDEX_PRODUCTION) $(QUERY_PRODUCTION) \
		$(LOOKASIDE_PRODUCTION)
	@ write sys$output "PRODUCTION Gopher Built!"
.ELSE
gopher : $(GOPHERD_EXE) $(BUILD_INDEX_EXE) $(QUERY_EXE) $(LOOKASIDE_EXE)
	@ write sys$output "DEBUG Gopher Built!"
.ENDIF
.IFDEF ARCHIVE
	$(MMS) $(MMSQUALIFIERS) /DESC=ZIP
.ENDIF
.IFDEF INDEX
	$(MMS) $(MMSQUALIFIERS) /DESC=INDEXING
.ENDIF

! Link the executables
.IFDEF PRODUCTION
$(GOPHERD_PRODUCTION) : $(GOPHERD_OBJECT) ident.opt multinetopt.opt
.ELSE
$(GOPHERD_EXE) : $(GOPHERD_OBJECT) ident.opt multinetopt.opt
.ENDIF
	link $(GOPHERD_DEBUG) /exe=$(GOPHERD_EXE) -
	$(GOPHERD_OBJECT), ident/opt, multinetopt/opt
.IFDEF PRODUCTION
	copy $(GOPHERD_EXE) $(GOPHERD_PRODUCTION)
.ENDIF

.IFDEF PRODUCTION
$(BUILD_INDEX_PRODUCTION) : $(BUILD_INDEX_OBJECT) ident.opt vaxc.opt
.ELSE
$(BUILD_INDEX_EXE) : $(BUILD_INDEX_OBJECT) ident.opt vaxc.opt
.ENDIF
	link $(GOPHERD_DEBUG) /exe=$(BUILD_INDEX_EXE) -
	$(BUILD_INDEX_OBJECT), ident/opt, vaxc/opt
.IFDEF PRODUCTION
	copy $(BUILD_INDEX_EXE) $(BUILD_INDEX_PRODUCTION)
.ENDIF

.IFDEF PRODUCTION
$(QUERY_PRODUCTION) : $(QUERY_OBJECT) ident.opt vaxc.opt
.ELSE
$(QUERY_EXE) : $(QUERY_OBJECT) ident.opt vaxc.opt
.ENDIF
	link $(GOPHERD_DEBUG) /exe=$(QUERY_EXE) -
	$(QUERY_OBJECT), ident/opt, vaxc/opt
.IFDEF PRODUCTION
	copy $(QUERY_EXE) $(QUERY_PRODUCTION)
.ENDIF

.IFDEF PRODUCTION
$(LOOKASIDE_PRODUCTION) : $(LOOKASIDE_OBJECT) ident.opt vaxc.opt
.ELSE
$(LOOKASIDE_EXE) : $(LOOKASIDE_OBJECT) ident.opt vaxc.opt
.ENDIF
	link $(GOPHERD_DEBUG) /exe=$(LOOKASIDE_EXE) -
	$(LOOKASIDE_OBJECT), ident/opt, vaxc/opt
.IFDEF PRODUCTION
	copy $(LOOKASIDE_EXE) $(LOOKASIDE_PRODUCTION)
.ENDIF

! Nested Header Files abound in this application
GOPHERD_H =-
 gopherd.h,-
 conf.h,-
 gopherdconf.h,-
 globals.h,-
 GDgopherdir.h,-
 DAarray.h,-
 GSgopherobj.h,-
 STRstring.h

GDGOPHERDIR_H =-
 GDgopherdir.h,-
 DAarray.h,-
 GSgopherobj.h,-
 STRstring.h

GSGOPHEROBJ_H =-
 GSgopherobj.h,-
 STRstring.h

MALLOC_H =-
 Malloc.h,-
 Stdlib.h

EXT_H =-
 ext.h,-
 DAarray.h,-
 STRstring.h,-
 boolean.h

SITE_H =-
 site.h,-
 DAarray.h,-
 STRstring.h,-
 boolean.h

! A default compilation procedure
.c.obj
	if f$search("$*.dia") then dele $*.dia;*
	cc/list/define=("MULTINET","SERVER")/object=$*.obj $*.c

! Define dependencies for all object files
gopherd.obj : gopherd.c $(GOPHERD_H) compatible.h

index.obj : index.c $(GOPHERD_H)

ftp.obj : ftp.c $(GOPHERD_H) debug.h

waisgopher.obj : waisgopher.c

special.obj : special.c $(GOPHERD_H)

kernutils.obj : kernutils.c gopherd.h gopherdconf.h

globals.obj : globals.c $(GOPHERD_H)

gdgopherdir.obj : gdgopherdir.c $(MALLOC_H)  $(GDGOPHERDIR_H)

site.obj : site.c $(MALLOC_H) $(SITE_H)

ext.obj : ext.c $(MALLOC_H) $(EXT_H)

util.obj : util.c $(MALLOC_H) string.h boolean.h util.h

gsgopherobj.obj : gsgopherobj.c $(MALLOC_H) $(GSGOPHEROBJ_H) compatible.h string.h 

compatible.obj : compatible.c $(MALLOC_H) compatible.h

daarray.obj : daarray.c $(MALLOC_H) daarray.h

strstring.obj : strstring.c $(MALLOC_H) string.h strstring.h

sockets.obj : sockets.c boolean.h compatible.h sockets.h

debug.obj : debug.c

build_index.obj : build_index.c

query.obj : query.c

lookaside.obj : lookaside.c gsgopherobj.h

indexcld.obj : indexcld.cld
	set command/list/object indexcld.cld
